# coding: utf-8

"""
    VMware Aria Automation Assembler / CMX Service API

    When using Kubernetes integration, deploy and manage Kubernetes clusters and namespaces. The APIs that list collections of resources also support OData like implementation. Below query params can be used across CMX entities.  Example:  1. `$orderby` - returns a result with the rows being sorted by the values of provided attribute.      ```/cmx/api/resources/tags?$orderby=name%20desc```  2. `$top`, `$skip` - `$top` returns the requested number of resources. Used with `$skip`, the client can skip a given number of resources.      ```/cmx/api/resources/tags?$expand=true&$top=10&$skip=2```  3. `page` and `$size` - page used in conjunction with `$size` helps in pagination of resources.      ```/cmx/api/resources/tags?$expand=true&page=0&$size=5```  4. `$filter` - `$filter` returns a subset of resources that satisfy the given predicate expression.      ```     /cmx/api/resources/tags?$filter=startswith(name, 'K8S')   # noqa: E501

    OpenAPI spec version: 2019-09-12
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class CmxapiresourcesvsphereendpointsendpointSelfLinkIdvirtualmachineclassesdescribedMetadata(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'annotations': 'dict(str, str)',
        'creation_timestamp': 'str',
        'deletion_grace_period_seconds': 'int',
        'deletion_timestamp': 'str',
        'finalizers': 'list[str]',
        'generate_name': 'str',
        'generation': 'int',
        'labels': 'dict(str, str)',
        'managed_fields': 'list[CmxapiresourcesvsphereendpointsendpointSelfLinkIdvirtualmachineclassesdescribedMetadataManagedFields]',
        'name': 'str',
        'namespace': 'str',
        'owner_references': 'list[CmxapiresourcesvsphereendpointsendpointSelfLinkIdvirtualmachineclassesdescribedMetadataOwnerReferences]',
        'resource_version': 'str',
        'self_link': 'str',
        'uid': 'str'
    }

    attribute_map = {
        'annotations': 'annotations',
        'creation_timestamp': 'creationTimestamp',
        'deletion_grace_period_seconds': 'deletionGracePeriodSeconds',
        'deletion_timestamp': 'deletionTimestamp',
        'finalizers': 'finalizers',
        'generate_name': 'generateName',
        'generation': 'generation',
        'labels': 'labels',
        'managed_fields': 'managedFields',
        'name': 'name',
        'namespace': 'namespace',
        'owner_references': 'ownerReferences',
        'resource_version': 'resourceVersion',
        'self_link': 'selfLink',
        'uid': 'uid'
    }

    def __init__(self, annotations=None, creation_timestamp=None, deletion_grace_period_seconds=None, deletion_timestamp=None, finalizers=None, generate_name=None, generation=None, labels=None, managed_fields=None, name=None, namespace=None, owner_references=None, resource_version=None, self_link=None, uid=None):  # noqa: E501
        """CmxapiresourcesvsphereendpointsendpointSelfLinkIdvirtualmachineclassesdescribedMetadata - a model defined in Swagger"""  # noqa: E501
        self._annotations = None
        self._creation_timestamp = None
        self._deletion_grace_period_seconds = None
        self._deletion_timestamp = None
        self._finalizers = None
        self._generate_name = None
        self._generation = None
        self._labels = None
        self._managed_fields = None
        self._name = None
        self._namespace = None
        self._owner_references = None
        self._resource_version = None
        self._self_link = None
        self._uid = None
        self.discriminator = None
        if annotations is not None:
            self.annotations = annotations
        if creation_timestamp is not None:
            self.creation_timestamp = creation_timestamp
        if deletion_grace_period_seconds is not None:
            self.deletion_grace_period_seconds = deletion_grace_period_seconds
        if deletion_timestamp is not None:
            self.deletion_timestamp = deletion_timestamp
        if finalizers is not None:
            self.finalizers = finalizers
        if generate_name is not None:
            self.generate_name = generate_name
        if generation is not None:
            self.generation = generation
        if labels is not None:
            self.labels = labels
        if managed_fields is not None:
            self.managed_fields = managed_fields
        if name is not None:
            self.name = name
        if namespace is not None:
            self.namespace = namespace
        if owner_references is not None:
            self.owner_references = owner_references
        if resource_version is not None:
            self.resource_version = resource_version
        if self_link is not None:
            self.self_link = self_link
        if uid is not None:
            self.uid = uid

    @property
    def annotations(self):
        """Gets the annotations of this CmxapiresourcesvsphereendpointsendpointSelfLinkIdvirtualmachineclassesdescribedMetadata.  # noqa: E501


        :return: The annotations of this CmxapiresourcesvsphereendpointsendpointSelfLinkIdvirtualmachineclassesdescribedMetadata.  # noqa: E501
        :rtype: dict(str, str)
        """
        return self._annotations

    @annotations.setter
    def annotations(self, annotations):
        """Sets the annotations of this CmxapiresourcesvsphereendpointsendpointSelfLinkIdvirtualmachineclassesdescribedMetadata.


        :param annotations: The annotations of this CmxapiresourcesvsphereendpointsendpointSelfLinkIdvirtualmachineclassesdescribedMetadata.  # noqa: E501
        :type: dict(str, str)
        """

        self._annotations = annotations

    @property
    def creation_timestamp(self):
        """Gets the creation_timestamp of this CmxapiresourcesvsphereendpointsendpointSelfLinkIdvirtualmachineclassesdescribedMetadata.  # noqa: E501


        :return: The creation_timestamp of this CmxapiresourcesvsphereendpointsendpointSelfLinkIdvirtualmachineclassesdescribedMetadata.  # noqa: E501
        :rtype: str
        """
        return self._creation_timestamp

    @creation_timestamp.setter
    def creation_timestamp(self, creation_timestamp):
        """Sets the creation_timestamp of this CmxapiresourcesvsphereendpointsendpointSelfLinkIdvirtualmachineclassesdescribedMetadata.


        :param creation_timestamp: The creation_timestamp of this CmxapiresourcesvsphereendpointsendpointSelfLinkIdvirtualmachineclassesdescribedMetadata.  # noqa: E501
        :type: str
        """

        self._creation_timestamp = creation_timestamp

    @property
    def deletion_grace_period_seconds(self):
        """Gets the deletion_grace_period_seconds of this CmxapiresourcesvsphereendpointsendpointSelfLinkIdvirtualmachineclassesdescribedMetadata.  # noqa: E501


        :return: The deletion_grace_period_seconds of this CmxapiresourcesvsphereendpointsendpointSelfLinkIdvirtualmachineclassesdescribedMetadata.  # noqa: E501
        :rtype: int
        """
        return self._deletion_grace_period_seconds

    @deletion_grace_period_seconds.setter
    def deletion_grace_period_seconds(self, deletion_grace_period_seconds):
        """Sets the deletion_grace_period_seconds of this CmxapiresourcesvsphereendpointsendpointSelfLinkIdvirtualmachineclassesdescribedMetadata.


        :param deletion_grace_period_seconds: The deletion_grace_period_seconds of this CmxapiresourcesvsphereendpointsendpointSelfLinkIdvirtualmachineclassesdescribedMetadata.  # noqa: E501
        :type: int
        """

        self._deletion_grace_period_seconds = deletion_grace_period_seconds

    @property
    def deletion_timestamp(self):
        """Gets the deletion_timestamp of this CmxapiresourcesvsphereendpointsendpointSelfLinkIdvirtualmachineclassesdescribedMetadata.  # noqa: E501


        :return: The deletion_timestamp of this CmxapiresourcesvsphereendpointsendpointSelfLinkIdvirtualmachineclassesdescribedMetadata.  # noqa: E501
        :rtype: str
        """
        return self._deletion_timestamp

    @deletion_timestamp.setter
    def deletion_timestamp(self, deletion_timestamp):
        """Sets the deletion_timestamp of this CmxapiresourcesvsphereendpointsendpointSelfLinkIdvirtualmachineclassesdescribedMetadata.


        :param deletion_timestamp: The deletion_timestamp of this CmxapiresourcesvsphereendpointsendpointSelfLinkIdvirtualmachineclassesdescribedMetadata.  # noqa: E501
        :type: str
        """

        self._deletion_timestamp = deletion_timestamp

    @property
    def finalizers(self):
        """Gets the finalizers of this CmxapiresourcesvsphereendpointsendpointSelfLinkIdvirtualmachineclassesdescribedMetadata.  # noqa: E501


        :return: The finalizers of this CmxapiresourcesvsphereendpointsendpointSelfLinkIdvirtualmachineclassesdescribedMetadata.  # noqa: E501
        :rtype: list[str]
        """
        return self._finalizers

    @finalizers.setter
    def finalizers(self, finalizers):
        """Sets the finalizers of this CmxapiresourcesvsphereendpointsendpointSelfLinkIdvirtualmachineclassesdescribedMetadata.


        :param finalizers: The finalizers of this CmxapiresourcesvsphereendpointsendpointSelfLinkIdvirtualmachineclassesdescribedMetadata.  # noqa: E501
        :type: list[str]
        """

        self._finalizers = finalizers

    @property
    def generate_name(self):
        """Gets the generate_name of this CmxapiresourcesvsphereendpointsendpointSelfLinkIdvirtualmachineclassesdescribedMetadata.  # noqa: E501


        :return: The generate_name of this CmxapiresourcesvsphereendpointsendpointSelfLinkIdvirtualmachineclassesdescribedMetadata.  # noqa: E501
        :rtype: str
        """
        return self._generate_name

    @generate_name.setter
    def generate_name(self, generate_name):
        """Sets the generate_name of this CmxapiresourcesvsphereendpointsendpointSelfLinkIdvirtualmachineclassesdescribedMetadata.


        :param generate_name: The generate_name of this CmxapiresourcesvsphereendpointsendpointSelfLinkIdvirtualmachineclassesdescribedMetadata.  # noqa: E501
        :type: str
        """

        self._generate_name = generate_name

    @property
    def generation(self):
        """Gets the generation of this CmxapiresourcesvsphereendpointsendpointSelfLinkIdvirtualmachineclassesdescribedMetadata.  # noqa: E501


        :return: The generation of this CmxapiresourcesvsphereendpointsendpointSelfLinkIdvirtualmachineclassesdescribedMetadata.  # noqa: E501
        :rtype: int
        """
        return self._generation

    @generation.setter
    def generation(self, generation):
        """Sets the generation of this CmxapiresourcesvsphereendpointsendpointSelfLinkIdvirtualmachineclassesdescribedMetadata.


        :param generation: The generation of this CmxapiresourcesvsphereendpointsendpointSelfLinkIdvirtualmachineclassesdescribedMetadata.  # noqa: E501
        :type: int
        """

        self._generation = generation

    @property
    def labels(self):
        """Gets the labels of this CmxapiresourcesvsphereendpointsendpointSelfLinkIdvirtualmachineclassesdescribedMetadata.  # noqa: E501


        :return: The labels of this CmxapiresourcesvsphereendpointsendpointSelfLinkIdvirtualmachineclassesdescribedMetadata.  # noqa: E501
        :rtype: dict(str, str)
        """
        return self._labels

    @labels.setter
    def labels(self, labels):
        """Sets the labels of this CmxapiresourcesvsphereendpointsendpointSelfLinkIdvirtualmachineclassesdescribedMetadata.


        :param labels: The labels of this CmxapiresourcesvsphereendpointsendpointSelfLinkIdvirtualmachineclassesdescribedMetadata.  # noqa: E501
        :type: dict(str, str)
        """

        self._labels = labels

    @property
    def managed_fields(self):
        """Gets the managed_fields of this CmxapiresourcesvsphereendpointsendpointSelfLinkIdvirtualmachineclassesdescribedMetadata.  # noqa: E501


        :return: The managed_fields of this CmxapiresourcesvsphereendpointsendpointSelfLinkIdvirtualmachineclassesdescribedMetadata.  # noqa: E501
        :rtype: list[CmxapiresourcesvsphereendpointsendpointSelfLinkIdvirtualmachineclassesdescribedMetadataManagedFields]
        """
        return self._managed_fields

    @managed_fields.setter
    def managed_fields(self, managed_fields):
        """Sets the managed_fields of this CmxapiresourcesvsphereendpointsendpointSelfLinkIdvirtualmachineclassesdescribedMetadata.


        :param managed_fields: The managed_fields of this CmxapiresourcesvsphereendpointsendpointSelfLinkIdvirtualmachineclassesdescribedMetadata.  # noqa: E501
        :type: list[CmxapiresourcesvsphereendpointsendpointSelfLinkIdvirtualmachineclassesdescribedMetadataManagedFields]
        """

        self._managed_fields = managed_fields

    @property
    def name(self):
        """Gets the name of this CmxapiresourcesvsphereendpointsendpointSelfLinkIdvirtualmachineclassesdescribedMetadata.  # noqa: E501


        :return: The name of this CmxapiresourcesvsphereendpointsendpointSelfLinkIdvirtualmachineclassesdescribedMetadata.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this CmxapiresourcesvsphereendpointsendpointSelfLinkIdvirtualmachineclassesdescribedMetadata.


        :param name: The name of this CmxapiresourcesvsphereendpointsendpointSelfLinkIdvirtualmachineclassesdescribedMetadata.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def namespace(self):
        """Gets the namespace of this CmxapiresourcesvsphereendpointsendpointSelfLinkIdvirtualmachineclassesdescribedMetadata.  # noqa: E501


        :return: The namespace of this CmxapiresourcesvsphereendpointsendpointSelfLinkIdvirtualmachineclassesdescribedMetadata.  # noqa: E501
        :rtype: str
        """
        return self._namespace

    @namespace.setter
    def namespace(self, namespace):
        """Sets the namespace of this CmxapiresourcesvsphereendpointsendpointSelfLinkIdvirtualmachineclassesdescribedMetadata.


        :param namespace: The namespace of this CmxapiresourcesvsphereendpointsendpointSelfLinkIdvirtualmachineclassesdescribedMetadata.  # noqa: E501
        :type: str
        """

        self._namespace = namespace

    @property
    def owner_references(self):
        """Gets the owner_references of this CmxapiresourcesvsphereendpointsendpointSelfLinkIdvirtualmachineclassesdescribedMetadata.  # noqa: E501


        :return: The owner_references of this CmxapiresourcesvsphereendpointsendpointSelfLinkIdvirtualmachineclassesdescribedMetadata.  # noqa: E501
        :rtype: list[CmxapiresourcesvsphereendpointsendpointSelfLinkIdvirtualmachineclassesdescribedMetadataOwnerReferences]
        """
        return self._owner_references

    @owner_references.setter
    def owner_references(self, owner_references):
        """Sets the owner_references of this CmxapiresourcesvsphereendpointsendpointSelfLinkIdvirtualmachineclassesdescribedMetadata.


        :param owner_references: The owner_references of this CmxapiresourcesvsphereendpointsendpointSelfLinkIdvirtualmachineclassesdescribedMetadata.  # noqa: E501
        :type: list[CmxapiresourcesvsphereendpointsendpointSelfLinkIdvirtualmachineclassesdescribedMetadataOwnerReferences]
        """

        self._owner_references = owner_references

    @property
    def resource_version(self):
        """Gets the resource_version of this CmxapiresourcesvsphereendpointsendpointSelfLinkIdvirtualmachineclassesdescribedMetadata.  # noqa: E501


        :return: The resource_version of this CmxapiresourcesvsphereendpointsendpointSelfLinkIdvirtualmachineclassesdescribedMetadata.  # noqa: E501
        :rtype: str
        """
        return self._resource_version

    @resource_version.setter
    def resource_version(self, resource_version):
        """Sets the resource_version of this CmxapiresourcesvsphereendpointsendpointSelfLinkIdvirtualmachineclassesdescribedMetadata.


        :param resource_version: The resource_version of this CmxapiresourcesvsphereendpointsendpointSelfLinkIdvirtualmachineclassesdescribedMetadata.  # noqa: E501
        :type: str
        """

        self._resource_version = resource_version

    @property
    def self_link(self):
        """Gets the self_link of this CmxapiresourcesvsphereendpointsendpointSelfLinkIdvirtualmachineclassesdescribedMetadata.  # noqa: E501


        :return: The self_link of this CmxapiresourcesvsphereendpointsendpointSelfLinkIdvirtualmachineclassesdescribedMetadata.  # noqa: E501
        :rtype: str
        """
        return self._self_link

    @self_link.setter
    def self_link(self, self_link):
        """Sets the self_link of this CmxapiresourcesvsphereendpointsendpointSelfLinkIdvirtualmachineclassesdescribedMetadata.


        :param self_link: The self_link of this CmxapiresourcesvsphereendpointsendpointSelfLinkIdvirtualmachineclassesdescribedMetadata.  # noqa: E501
        :type: str
        """

        self._self_link = self_link

    @property
    def uid(self):
        """Gets the uid of this CmxapiresourcesvsphereendpointsendpointSelfLinkIdvirtualmachineclassesdescribedMetadata.  # noqa: E501


        :return: The uid of this CmxapiresourcesvsphereendpointsendpointSelfLinkIdvirtualmachineclassesdescribedMetadata.  # noqa: E501
        :rtype: str
        """
        return self._uid

    @uid.setter
    def uid(self, uid):
        """Sets the uid of this CmxapiresourcesvsphereendpointsendpointSelfLinkIdvirtualmachineclassesdescribedMetadata.


        :param uid: The uid of this CmxapiresourcesvsphereendpointsendpointSelfLinkIdvirtualmachineclassesdescribedMetadata.  # noqa: E501
        :type: str
        """

        self._uid = uid

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(CmxapiresourcesvsphereendpointsendpointSelfLinkIdvirtualmachineclassesdescribedMetadata, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CmxapiresourcesvsphereendpointsendpointSelfLinkIdvirtualmachineclassesdescribedMetadata):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
